/* 
        Mms.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/


#include "Mms.h"

/*
*constructor for Mms
*/
Mms::Mms (const int __argc,char** const __argv,
	  const char* const filename,
	  XMMS_OPTION xmmsOption):
  argc (__argc),argv (__argv),
  scenario (NULL),
  timer (60*100),
  numberOfNak (0),numberOfMmsPalette (0),numberOfPcm (0),
  numberOfCall (0),numberOfLoop (0),
  timeCntForWait (0), isTimerWaiting (False),
  isAudioWriting (0),isAudioWaiting (0),
  xmmsOption (xmmsOption)
{
  ////////////////////////////////////////ѿ
  for (int i=0;i<MAXNAK;i++)
    pNak[i]=NULL;
  for (int i=0;i<MAXPAL;i++)
    pMmsPalette[i]=NULL;
  for (int i=0;i<MAXPCM;i++)
    pPcm[i]=NULL;
  setXMmsOption (xmmsOption);
  memset (virtualVram,0,VIRTUAL_VRAM_LENGTH);
  
  ////////////////////////////////////////////////XϢ
  //¾(defaultȤ鷺ˤvisual classꤹ٤)
  //fileload
  if (!loadAll (filename))
    {//fileloadʤä
      cerr << "Can not load masl file." << endl;
      exit (-1);//λ
    }

  mmsWindow=new MmsSvgaWindow (&xmmsOption);
}


Mms::~Mms ()
{
  delete scenario;
  {for (int i=0;i<MAXNAK;i++) delete pNak[i];}
  {for (int i=0;i<MAXPAL;i++) delete pMmsPalette[i];}
  {for (int i=0;i<MAXPCM;i++) delete pPcm[i];}
  //delete nakAead;

  delete mmsWindow;
}

////////////////////////////////////////////////xmaslФoptionν
void Mms::setXMmsOption (XMMS_OPTION xmmsOption)
{
  if (xmmsOption.isNoSound)
    MaslAudio::disableAudio ();

#ifdef RENICE
  if (xmmsOption.isRenice)
    {
      if (setpriority (PRIO_PROCESS,0,RENICE_LEVEL)==-1)
	perror ("can not set priority");
    }
  uid_t userId=getuid ();
  setuid (userId);
  //setreuid (userId,userId);
#endif//RENICE
}

/*
*ak5 dataɤ߹
*/
Bool Mms::loadNak (MaslInputStream& maslIs)
{
  unsigned int length;
  /////////////////////////////////////////////////data lenghtɤ߹
  length=maslIs.get32 ();
  
  if (length==0)
    length-=1;
  
  long endptr=maslIs.tellg ()+length;//ak5 dataνü

  ///////////////////////////////////////////////////NAK ɤ߹
  char nak[9];
  maslIs.read (nak,8);
  nak[8]='\0';
  if (strncmp (nak,"NAK",3)!=0)
    {
      cerr << "Incorrect data format detected." << endl;
      return False;
    }
  
  //ΰϲ򤷤Ƥ뤫(commentΰ褫)
  char auther[32];
  maslIs.read (auther,32);//̾
  int tmpsize=maslIs.get16 ();
  maslIs.seekg (tmpsize,ios::cur);//commentΰ
  
  ///////////////////////////////////////////////////////dataɤ߹
  while (maslIs.tellg ()<endptr)
    {
      unsigned char nakId=maslIs.get8 ();
      

      
      switch (nakId)
	{
	case 0://palette dataɤ߹
	  delete pMmsPalette[numberOfMmsPalette];
	  pMmsPalette[numberOfMmsPalette++]=new MmsSvgaPalette(maslIs);
	  break;
	  
	case 1://ľ
	case 2://ľ
	case 3://dataɤ߹
	  delete pNak[numberOfNak];
	  //dataưŪŸ롣default
	  pNak[numberOfNak++]=new Nak (maslIs,nakId);
	  break;
	  
	default://̾Ϥؤʤ
	  cerr << "Incorrect NAk ID detected" << endl;
	  return False;
	}
    }
  return True;
}


/*
*pkn dataɤ߹
*/
Bool Mms::loadPkn (MaslInputStream& maslIs)
{
  ///////////////////////////data size
  unsigned int size;

  //data sizeɤ߹
  size=maslIs.get32 ();
  if (size==0)size-=1;
  
  long endptr=maslIs.tellg ()+size;//pkn dataνü

  ///////////////PKN* ɤ߹
  char PKN[8];
  maslIs.read (PKN,8);
  PKN[3]='\0';
  if (strcmp (PKN,"PKN"))
    {
      cerr << "Incorrect data format detected" << endl;
      return False;
    }
  

  //ΰϲ򤷤Ƥ뤫
  char fix[32];
  maslIs.read (fix,32);//ϲ⤷ʤ

  ///////////////////////////////////////////////////////dataɤ߹
  while (maslIs.tellg ()<endptr)
    {
      unsigned char type;
      type=maslIs.get ();

      delete pPcm[numberOfPcm];
      pPcm[numberOfPcm++]=new Pcm (type,maslIs);//pcm dataɤ߹
    }
  return True;
}


Bool Mms::loadAll (const char* const filename)
{
  //////////////////////////////////////////////ѿ
  numberOfNak=0;
  numberOfMmsPalette=0;
  numberOfPcm=0;
  //Nak,MmsPalette,PcmκֹФƤ٤ΤΡ
  //\cg,\pal,\pcmбΰ
  int maxNumberOfNak=0;
  int maxNumberOfMmsPalette=0;
  int maxNumberOfPcm=0;
  
  ///////////////////////////////////////////////fileopen
  MaslInputStream maslIs (filename,ios::in|ios::nocreate);
  
  if (!maslIs)
    {
      cerr << filename << ":File couldn't open.(file does not exst?)" << endl;
      return False;
    }
  
  ////////////////////////////////////////////////MSLɤ߹
  char MMS[9];
  maslIs.read (MMS,8);
  MMS[8]='\0';
  if (strncmp (MMS,"MMS",3)!=0)
    {
      cerr<< "This is not MMS file" << endl;
      maslIs.close ();
      return False;
    }
  
  /////////////////////////////////////////scenarioSizeɤ߹
  const int scenarioSize=maslIs.get16 ();

  ///////////////////////////////////////////scinarioɤ߹
  scenario=new MmsScenario(maslIs,scenarioSize);

  /////////////////////////////////////////////MASLcheck
  scenario->checkMagic ();

  /////////////////////////////////////////////commentɽ
  if (!xmmsOption.isNoPrintComment)
    //printComment (pt-numberOfCharInComment-1,numberOfCharInComment-1);
    scenario->printComment (xmmsOption.isSjis);


  /////////////////////////////////////////////////////ak5,pkn dataɤ߹
  cout << "\nnow loading nak and pkn..." << flush;
  //*.nak *.pknȤdata񤤤Ƥ롣
  //ǤνdataǼƤΤǤɤ߹
  //.ΤߤιԤн
  //while (*pt!='.')//.ΤߤιԤн
  for (const char* filename=scenario->getDataFilename ();
       filename!=NULL;
       filename=scenario->getDataFilename ())
    {
      //ե̾ΰ˰ʲΤ褦ʹԤä硢ֹ椬Ūѹޤ
      //'\cgN'  - ãֹN(01023)֤NϿͤΤߤǥ쥸Բġ
      //'\pcmN' - УãֹN(063)֤
      //'\palN' - ѥåֹN(0255)֤
      //㤨sample1.nakʣãǤ5ˤsample2.nakʣãǤ3ˤä
      //.
      //\cg5
      //sample1.nak
      //\cg1
      //sample2.nak
      //.
      //Τ褦˽񤫤Ƥ硢
      //ãֹ桡 5           9  1           3
      //sample1.nakϡsample2.nak
      //ƤȣãֹϰʾΤ褦ˤʤޤ
      //ֹ椬ѤäǥƤѲ̵ȤդƤ

      const char cg[]="\\cg";
      const char pcm[]="\\pcm";
      const char pal[]="\\pal";
      if (strncmp (filename,cg,strlen (cg))==0)
	{
	  numberOfNak=searchnum (filename+strlen (cg));
	  continue;
	}
      if (strncmp (filename,pcm,strlen (pcm))==0)
	{
	  numberOfPcm=searchnum (filename+strlen (pcm));
	  continue;
	}
      if (strncmp (filename,pal,strlen (pal))==0)
	{
	  numberOfMmsPalette=searchnum (filename+strlen (pal));
	  continue;
	}

      while (*filename!='.')filename++;//8+3:file̾γĥҤޤФ

      if ((filename[1]=='n' && filename[2]=='a' && filename[3]=='k') ||
	  (filename[1]=='N' && filename[2]=='A' && filename[3]=='K'))
	{//ĥҤnakޤNAKä
	  if (!loadNak (maslIs))//ak5 dataɤ߹
	    {//error
	      cerr << "NAK load Failur." << endl;
	      maslIs.close ();
	      return False;
	    }
	  
	  //ֹ+1ФƤ
	  if (maxNumberOfNak<numberOfNak)
	    maxNumberOfNak=numberOfNak;
	  if (maxNumberOfMmsPalette<numberOfMmsPalette)
	    maxNumberOfMmsPalette=numberOfMmsPalette;
	}
      else if ((filename[1]=='p' && filename[2]=='k' && filename[3]=='n') ||
	       (filename[1]=='P' && filename[2]=='K' && filename[3]=='N'))
	{//ĥҤpknޤPKNä
	  if (!loadPkn (maslIs))//pkn dataɤ߹
	    {//error
	      cerr << "PKN Load failure." << endl;
	      maslIs.close ();
	      return False;
	    }

	  //ֹ+1ФƤ
	  if (maxNumberOfPcm<numberOfPcm)
	    maxNumberOfPcm=numberOfPcm;
	}
      cout << "." << flush;
    }

  //Ǥ줾ֹ+1ˤʤ롣
  numberOfNak=maxNumberOfNak;
  numberOfMmsPalette=maxNumberOfMmsPalette;
  numberOfPcm=maxNumberOfPcm;  
  maslIs.close ();//ɤ߹߽λ
  cout << 
"\rLoading done.                                                              "
       << endl;

  /////////keyԤ
  if (xmmsOption.isWaitBeforePlaying)
    waitBeforePlaying (scenario->getDocWaitValue ());
  
  //
  return True;
}


//////////////////////////////////////////////scenarioβϤΤmethod

int Mms::searchnum ()
{
  int ch;//dataɤ߹
  int fg=1;//
  int i=0;//ͤ

  pt=strpbrk (pt,"-0123456789");
  
  if (*pt=='-')
    {
      fg=-1;
      pt++;
    }
  
  while (isdigit (ch=(int (*pt))))
    {
      if (isdigit (ch))
	{
	  i*=10;
	  i+=ch-'0';
	}
      pt++;
    }
  return fg*i;
}

int Mms::searchnum (const char* pt)
{
  int ch;//dataɤ߹
  int fg=1;//
  int i=0;//ͤ
  
  pt=strpbrk (pt,"-0123456789");
  
  if (*pt=='-')
    {//ɤ߹
      fg=-1;
      pt++;
    }

  while (isdigit (ch= (int) (*pt)))
    {
      if (isdigit (ch))
	{
	  i*=10;//巫夲ơ
	  i+=ch-'0';//̤˿ɤ߹
	}
      pt++;
    }
  return fg*i;
}


Bool Mms::searchNextCommand ()
{//ͭtokenͭޤǡptʤ롣
  while ((*pt==':'||*pt==' '||*pt=='\t'||*pt=='\r'||*pt=='\n'||*pt==';')
	 &&scenario->isNotEnd (pt))
    {//򡢲ԤȤФ;ϥ
      if (*pt==';')
	{//ȤʤΤǲԤޤǤȤФ
	  pt++;
	  while (*(pt-2)!='\r'||*(pt-1)!='\n')
	    {
	      pt++;
	    }
	}
      else
	{
	  pt++;
	}
    }

  if (scenario->isEnd (pt))
    return False;
  else
    return True;
}

int Mms::getValue ()
{
  pt=strpbrk (pt,"-0123456789R@KOTPF");
  for (int i=0;i<NUMBER_VALUE;i++)
    {
      if (*pt==valueTable[i].value)
	{
	  return valueTable[i].getValue (*this);
	}
    }

  //̾ϤˤʤȦ
  return 0;//defaultͭäɤΤʤ
}

Bool Mms::joukenHantei ()
{
  switch (*pt)
    {
    case '=':
      {
	pt++;
	int n=getValue ();
	pt++;//commaɤФ
	return (n==getValue ())?True:False;
      }
    break;
    
    case '!':
      {
      pt++;
      int n=getValue ();
      pt++;//commaɤФ
      return (n!=getValue ())?True:False;
      }
    break;

    case '<':
      pt++;
      if (*pt=='=')
	{//⤷
	  pt++;
	  int n=getValue ();
	  pt++;//commaɤФ
	  return (n<=getValue ())?True:False;
	}
      else
	{
	  int n=getValue ();
	  pt++;//commaɤФ
	  return (n<getValue ())?True:False;
	}
      break;

    case '>':
      pt++;
      if (*pt=='=')
	{//⤷
	  pt++;
	  int n=getValue ();
	  pt++;//commaɤФ
	  return (n>=getValue ())?True:False;
	}
      else
	{
	  int n=getValue ();
	  pt++;//commaɤФ
	  return (n>getValue ())?True:False;      
	}
      break;

    default:
      return True;	
      break;
    }
}

int Mms::isKeyPressed (const KeySym keysym,const char keyVector[32])
{
#if 0
  KeyCode keycode=XKeysymToKeycode (display,keysym);
  if (keycode==NoSymbol)return (0);//̵̣key codeä

  return (1&(keyVector[(keycode/8)]>> (keycode&7)));
#endif
  return 0;
}


Bool Mms::isOptionSpecified (char c)
{
  for (int i=1;i<argc;i++)
    {
      const char* p=argv[i];
      if (*p!='/' && *p!='-')
	continue;
      p++;
      if (tolower (*p)==tolower (c))
	return True;
    }
  return False;
}

Bool Mms::isOptionSpecified2 (const char*& opts)
{
  for (int i=1;i<argc;i++)
    {
      const char* p=argv[i];
      if (*p!='/' && *p!='-')
	  continue;
      p++;
      if (tolower (*p)==tolower (*opts) &&
	  tolower (*(p+1))==tolower (*(opts+1)))
	{
	  opts+=2;
	  return True;
	}
    }
  opts+=2;
  return False;
}

int Mms::getOptionValue (char c)
{
  for (int i=1;i<argc;i++)
    {
      const char* p=argv[i];
      if (*p!='/' && *p!='-')
	continue;
      p++;
      if (tolower (*p)==tolower (c))
	return searchnum ((char*) p+1);//+1option'/'or'-'Ф
    }
  return 0;
}

////////////////////////////////////////////////////////Ԥ
void Mms::waitBeforePlaying (int docwait)
{//docwaitäΩĤʤˤkeyޤԤ
  timeval baseTime;
  timeval nowTime;
  gettimeofday (&baseTime,NULL);
  gettimeofday (&nowTime,NULL);
# if 0
  XEvent tmpEvent;//ϼXCheckMaskEventΰ˻Ȥ
  while (nowTime.tv_sec-baseTime.tv_sec<docwait &&
	 !XCheckMaskEvent (display,KeyPressMask||ExposureMask,&tmpEvent))
    gettimeofday (&nowTime,NULL);
#endif
}
