/* 
        MmsScenario.cc

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        $B$3$N(Bcode$B$O(Bshimarin$B$5$s$N(Bcode$B$r85$K(BYamahata$B$,=q$-D>$7$?J*$G$9!#(B
*/
#include <ctype.h>
//#include <cctype>
#include <string.h>
//#include <cstring>

#include "MmsScenario.h"

MmsScenario::MmsScenario (char* filename) :
  Scenario (filename)
{
  init ();
}

  
MmsScenario::MmsScenario (MaslInputStream& mmsIs,int mmsScenarioSize) :
  Scenario (mmsIs,mmsScenarioSize)
{
  init ();
}

MmsScenario::MmsScenario (char* data,int mmsScenarioSize):
  Scenario (data,mmsScenarioSize)
{
  init ();
}

MmsScenario::~MmsScenario ()
{
  //do nothing
}

void MmsScenario::showInfo ()
{
  //////////////scenario$B$N(Bcheck
  /////////////////////////////////////////////MASL$B$N(Bcheck
  if (!checkMagic ())
    exit (-1);

  cout << "M-Masl version=" << ver1 << "." << ver2 << endl;
  cout << "waiting time=" << docwait << "(sec.)" << endl;
}

Bool MmsScenario::checkMagic ()
{
  const char* const tmp=scenarioData;
  if (*tmp!='M'|| *(tmp+1)!='M' ||*(tmp+2)!='A'||*(tmp+3)!='S'||*(tmp+4)!='L')
    {
      cerr << "This file is not for MMASL." << endl;
      return False;
    }
  return True;
}

void MmsScenario::init ()
{
  pt=scenarioData;
  //checkMagic ();
  //pt+=4;
  ////////////////////////////////////Version Check ****.****  ver1.ver2
  while (!isdigit (*pt))//$B?t;z$N=j$^$GHt$P$9!#(B
    pt++;
  ver1=searchnum (pt);//major version
  pt++;//skip period
  ver2=searchnum (pt);//minor version
  //ver2$B$r7+$j>e$2$k!#(B($B>.?t0J2<$NI=<($K$9$k(B)
  if (ver2<10)
    ver2*=1000;
  else if (ver2<100)
    ver2*=100;
  else if (ver2<1000)
    ver2*=10;
  else 
    ver2=ver2%10000;
  while (*(pt-2)!='\r'||*(pt-1)!='\n')pt++;//version$B;XDj$+$i2~9T$^$GHt$P$:(B
  
  //comment$B$rHt$P$7$F;2>H$7$F$$$k(B.nak,.pkn file$B$NF,$^$G?J$`!#(B
  //data(.nak,.pkn file$B$,;XDj$7$F$"$k$H$3$m$^$GHt$P$9!#(B)
  comment=pt;
  commentSize=0;
  while (*(pt-2)!='\r'||*(pt-1)!='\n'||*pt!='.')
    {
      pt++;
      commentSize++;
    }

  pt++;
  //////////////////////$B:F@8$^$G$NBT$A;~4V<hF@(B('.'$B$N8e$N?t;z(B)
  if (isdigit (*(pt)))
    {//$BBT$A;~4V<hF@(B
      docwait=searchnum (pt);
    }
  else
    {//$BBT$A;~4V;XDjL5$7(B
      docwait=32767;//$B$3$N?t;z$K0UL#$OL5$7!#E,Ev$KBg$-$$?t;z(B
    }

  while (*(pt-2)!='\r'||*(pt-1)!='\n')
    pt++;//$B2~9T$^$GHt$P$9(B
  dataFilename=pt;
  if (*pt=='.' && *(pt+1)=='\r' && *(pt+2)=='\n')
    dataFilename=NULL;

  pt++;
  //mmsload$BEy$K;H$&NN0h$^$GHt$P$9!#(B
  while (*(pt-3)!='.'||*(pt-2)!='\r'||*(pt-1)!='\n')
    {
      pt++;
    }
  reserved=pt;
  if (*pt=='.' && *(pt+1)=='\r' && *(pt+2)=='\n')
    reserved=NULL;
  
  pt++;
  while (*(pt-3)!='.'||*(pt-2)!='\r'||*(pt-1)!='\n')
    {
      pt++;
    }
  beginPoint=pt;

  //////////////command$B$,=q$$$F$"$k$H$3$m$N=hM}!#(B
 while (*pt!='\\' && pt-scenarioData < scenarioSize)
    {
      if (*pt==';')
        {//';'$B0J9_$O$3$a$s$H(B
          *pt=' ';
          while (*(pt+1)!='\r' || *(pt+2)!='\n')
            {//$B$3$a$s$H$J$N$G!"2~9T$^$G6uGr$GDY$9(B
              *++pt=' ';
            }
        }
      else
        pt++;
    }

 pt=beginPoint;//$B8=:_$N0LCV$r(Bcommand$B$,;O$^$C$F$$$k:G=i$K$7$F$*$/!#(B
}
