/* 
        MmsSvgaPalette.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	shimarincode򸵤Yamahata񤤤ʪǤ
*/
#include <vga.h>
#include <vgagl.h>

#include "MmsSvgaPalette.h"

MmsSvgaPalette::PALETTE MmsSvgaPalette::paletteOfNow[NUM_OF_PALETTES][NUM_OF_COLORS];

MmsSvgaPalette::MmsSvgaPalette (MaslInputStream& maslIs)
{
  int commentSize=maslIs.get16 ();
  offset=maslIs.get16 ();
  offset/=3;////1paletteˤĤr,g,b3bytա
  size=maslIs.get16 ();
  maslIs.seekg (commentSize,ios::cur);//ΰcomment

  unsigned char* buffer=new unsigned char[size];//dataɤ߹Ѥbuffer
  maslIs.read (buffer,size);//dataɤ߹
  size/=3;//paletteθĿˤʤ롣(1paletteˤĤr,g,b3byte)
  palette=new PALETTE[size];
  int c=0;
  for (int i=0;i<size;i++)
    {//palette
      palette[i].r=buffer[c];
      c++;
      palette[i].g=buffer[c];
      c++;
      palette[i].b=buffer[c];
      c++;
    }
  delete[] buffer;
}

MmsSvgaPalette::~MmsSvgaPalette ()
{
  delete[] palette;
}

void MmsSvgaPalette::printData () const
{
  cout << "offset=" << offset << endl;
  cout << "size=" << size << endl;
  for (int i=0;i<size;i++)
    {
      cerr << i << "-th palette (r,g,b)=("
	   << (int) (palette[i].r) << ","
	   << (int) (palette[i].g) << ","
	   << (int) (palette[i].b) << ")"
	   << endl;
    }
}

void MmsSvgaPalette::setPalette (const int bufferNumber=0)
{//buffetNumber bufferpaletteȤϤɤ

  //check
  assert (bufferNumber==0||bufferNumber==1);
  assert (offset+size<=NUM_OF_COLORS);
  
  for (int i=0;i<size;i++)
    {
      /////////////////ꤵƤpaletteФƤ
      paletteOfNow[bufferNumber][abs(i+offset)%NUM_OF_COLORS].r=palette[i].r;
      paletteOfNow[bufferNumber][abs(i+offset)%NUM_OF_COLORS].g=palette[i].g;
      paletteOfNow[bufferNumber][abs(i+offset)%NUM_OF_COLORS].b=palette[i].b;

    }

  if (bufferNumber==0)
    {//
      vga_lockvc ();
      if (vga_oktowrite ())
	{
	  for (int i=0;i<size;i++)
	    {
	      gl_setpalettecolor ((offset+i)&255,
				  (palette[i].r >> 2)%64,
				  (palette[i].g >> 2)%64,
				  (palette[i].b >> 2)%64);
	    }
	}
      vga_unlockvc ();
    }
}

void MmsSvgaPalette::restorePalette ()
{  //graphic mode㤨Ȥ˥ѥåȤ̵ˤʤΤǤꤹ뤿Υ᥽å
  //κ
  PALETTE xcolors[NUM_OF_COLORS];
  for (int i=0;i<NUM_OF_COLORS;i++)
    {
      xcolors[i].r=(paletteOfNow[0][i].r >> 2)%64;
      xcolors[i].g=(paletteOfNow[0][i].g >> 2)%64;
      xcolors[i].b=(paletteOfNow[0][i].b >> 2)%64;
    }
  vga_lockvc ();
  if (vga_oktowrite ())
    gl_setpalettecolors (0,NUM_OF_COLORS,xcolors);
  vga_unlockvc ();
}



void MmsSvgaPalette::setPalette (const int paletteNumber,
			     const int r,const int g,const int b,
			     const int bufferNumber=0)
{
  ////////check
  assert (0<=paletteNumber);
  assert (paletteNumber<NUM_OF_COLORS);
  assert (0<=r);
  assert (r<256);
  assert (0<=g);
  assert (g<256);
  assert (0<=b);
  assert (b<256);
  assert (bufferNumber==0||bufferNumber==1);
  
  /////////////////ꤵƤpaletteФƤ
  paletteOfNow[bufferNumber][paletteNumber].r=r;
  paletteOfNow[bufferNumber][paletteNumber].g=g;
  paletteOfNow[bufferNumber][paletteNumber].b=b;

  if (bufferNumber==0)
    {
      vga_lockvc ();
      if (vga_oktowrite ())
	gl_setpalettecolor (paletteNumber&255,
			    (r >> 2)%64,(g >> 2)%64,(b >> 2)%64);
      vga_unlockvc ();
    }
}

void MmsSvgaPalette::setPTone (const int contrast,const int ratio,
			       const int startColorNumber,
			       const int lastColorNumber)
{
  assert (0<=startColorNumber);
  assert (lastColorNumber<=NUM_OF_COLORS);

  const int numberOfColors=lastColorNumber-startColorNumber+1;
  vga_lockvc ();
  if (!vga_oktowrite ())
    {
      vga_unlockvc ();
      return;
    }
  for (int i=0;i<numberOfColors;i++)
    {
      const int r=((((paletteOfNow[0][i+startColorNumber].r*(256-ratio)+
		      paletteOfNow[1][i+startColorNumber].r*ratio)/256)
		    *contrast/256) >> 2)%64;
      const int g=((((paletteOfNow[0][i+startColorNumber].g*(256-ratio)+
		      paletteOfNow[1][i+startColorNumber].g*ratio)/256)
		    *contrast/256)>> 2)%64;
      const int b=((((paletteOfNow[0][i+startColorNumber].b*(256-ratio)+
		      paletteOfNow[1][i+startColorNumber].b*ratio)/256)
		    *contrast/256) >> 2)%64;
      gl_setpalettecolor ((startColorNumber+i)&255,r,g,b);
    }
  vga_unlockvc ();
}

