/* 
        Nak.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarinwin maslβŸ򸵤Yamahata
	ޤ
*/

#include "Nak.h"

Nak::Nak (MaslInputStream& maslIs,const unsigned char mmsNakId):
  nakId (mmsNakId),nakData (NULL)
{
  int commentSize=maslIs.get16 ();
  dataSize=maslIs.get16 ();
  left=maslIs.get16 ();
  top=maslIs.get16 ();

  right=maslIs.get16 ();
  bottom=maslIs.get16 ();
/*
#ifdef DEBUG
  cerr << "left=" << left << endl;
  cerr << "top=" << top << endl;
  cerr << "right=" << right << endl;
  cerr << "bottom=" << bottom << endl;
#endif  
*/
  maslIs.seekg (commentSize,ios::cur);
  nakData= new unsigned char[dataSize];
  maslIs.read (nakData,dataSize);
}

Nak::Nak ():
  nakData (NULL)//,
{
  //do nothing
}

Nak::~Nak ()
{
  delete[] nakData;
}

void Nak::putImage (Display* const display,Visual* const visual,
		    const Drawable drawable,const GC gc,
		    unsigned char* const imageData,
		    const int lengthOfData,
		    const unsigned char palette2Pixel[NUM_OF_COLORS],
		    const int left=0,const int top=0)
{
  extractNak2Vram (nakData,imageData);

  unsigned char* ximageData=new unsigned char[VIRTUAL_VRAM_LENGTH];
  XImage* ximage=XCreateImage (display,visual,8,ZPixmap,0,
				      (char*) imageData,
				      VIRTUAL_VRAM_SIZE_X,VIRTUAL_VRAM_SIZE_Y,
				      8,0);

  for (int i=0;i<lengthOfData;i++)
    ximageData[i]=palette2Pixel[imageData[i]];
#ifdef MITSHM
  XShmPutImage (display,drawable,gc,ximage,
                0,0,left,top,VIRTUAL_VRAM_SIZE_X,VIRTUAL_VRAM_SIZE_Y,False);
#else
  XPutImage (display,drawable,gc,ximage,0,0,left,top,
             VIRTUAL_VRAM_SIZE_X,VIRTUAL_VRAM_SIZE_Y);
#endif//MITSHM
  delete[] ximageData;
  ximage->data=NULL;
  XDestroyImage (ximage);
}

/////////////////////////////////////////////////XImage->dataؿ
void Nak::moveRect (unsigned char* const imageData,
		    const int srcLeft,const int srcTop,
		    const int destLeft,const int destTop,
		    const int width,const int height)
{
  unsigned char* tmp=new unsigned char[width*height];
  //staticˤɤʤ

  {//moveζФƤ
    for (int y=0;y<height;y++)
      memcpy (tmp+y*width,
	      imageData+srcLeft+(srcTop+y)*VIRTUAL_VRAM_SIZE_X,
	      width);
  }
  {//ĥդ褹
    for (int y=0;y<height;y++)
      memcpy (imageData+destLeft+(destTop+y)*VIRTUAL_VRAM_SIZE_X,
	      tmp+y*width,
	      width);
  }
  delete[] tmp;
}

void Nak::orMoveRect (unsigned char* const imageData,
		      const int srcLeft,const int srcTop,
		      const int destLeft,const destTop,
		      const int width,const int height,
		      const int shift)
{
  unsigned char* tmp=new unsigned char[width*height];
  //staticˤɤʤ
  
  {//moveζФƤ
    for (int y=0;y<height;y++)
      memcpy (tmp+y*width,
	      imageData+srcLeft+(srcTop+y)*VIRTUAL_VRAM_SIZE_X,
	      (unsigned int) width);
  }

  //shiftshift롣shiftȤϤɤäͤʤ
  //괺shiftˤƤߤɡ
  for (int i=0;i<width*height;i++)
    tmp[i]=(tmp[i]<< shift)|(tmp[i] >> 8-shift);
    //tmp[i]<<=shift;


  {//ĥդorȤä褹
    for (int y=0;y<height;y++)
      {
	for (int x=0;x<width;x++)
	  *(imageData+destLeft+x+(destTop+y)*VIRTUAL_VRAM_SIZE_X)|=
	    tmp[x+y*width];
      }
  }
  delete[] tmp;
}

void Nak::zoom (unsigned char* const imageData,
		const int srcLeft,const int srcTop,
		const int destLeft,const int destTop,
		const int srcWidth,const int srcHeight,
		const int destWidth,const int destHeight,
		const int transparentFlag=0,const int transparentColor=0)
{
  const int signOfSrcWidth=signOf (srcWidth);
  const int signOfSrcHeight=signOf (srcHeight);
  const int signOfDestWidth=signOf (destWidth);
  const int signOfDestHeight=signOf (destHeight);

  const int absSrcWidth=signOfSrcWidth*srcWidth;
  const int absSrcHeight=signOfSrcHeight*srcHeight;
  const int absDestWidth=signOfDestWidth*destWidth;
  const int absDestHeight=signOfDestHeight*destHeight;
  
  //ʲabsSrctWidth/absDestWidthϤɤΤɤΤʤ
  //over flowʤ
  for (int y=0;y<abs (destHeight);y++)
    {
      for (int x=0;x<abs (destWidth);x++)
	{
	  const int srcOffset=
	    (srcLeft+signOfSrcWidth*x*absSrcWidth/absDestWidth)+
	    (srcTop+signOfSrcHeight*y*absSrcHeight/absDestHeight)*
	    VIRTUAL_VRAM_SIZE_X;
	  
	  if (transparentFlag==1 &&
	      imageData[srcOffset]==transparentColor)
	    continue;

	  imageData[(destLeft+signOfDestWidth*x)+
		   (destTop+signOfDestHeight*y)*VIRTUAL_VRAM_SIZE_X]=
	    imageData[srcOffset];
	}
    }
}

void Nak::drawBox (unsigned char* const imageData,
		   const int left,const int top,
		   const int right,const int bottom,
		   const unsigned char color)
{
  assert (left<=right);
  assert (top<=bottom);
  //βϤܤʤΤʤޤľΤϴñɡ

  const int width=right-left+1;
  const int height=bottom-top+1;
  for (int y=0;y<height;y++)
    memset (imageData+left+(top+y)*VIRTUAL_VRAM_SIZE_X,color,width);
}

void Nak::setPoint (unsigned char* const imageData,
		    const int x,const int y,const unsigned char color)
{
  *(imageData+x+y*VIRTUAL_VRAM_SIZE_X)=color;
}

int Nak::getPoint (unsigned char* const imageData,const int x,const int y)
{
  return *(imageData+x+y*VIRTUAL_VRAM_SIZE_X);
}

void Nak::setPointWord (unsigned char* const imageData,
			const int x,const int y,
			const unsigned int wordColor)
{
  /////////////ɤΤʤendianδطǵդΤ줺
/*
  *(imageData+x+y*VIRTUAL_VRAM_SIZE_X)=(wordColor >> 8);
  *(imageData+x+y*VIRTUAL_VRAM_SIZE_X+1)=(wordColor & 0xff);
*/
  *(imageData+x+y*VIRTUAL_VRAM_SIZE_X)=(wordColor & 0xff);
  *(imageData+x+y*VIRTUAL_VRAM_SIZE_X+1)=(wordColor >> 8);
}

int Nak::getPointWord (unsigned char* const imageData,const int x,const int y)
{
  //ɤΤʤendianΤǴְäƤ뤫⡩
  return *(imageData+x+y*VIRTUAL_VRAM_SIZE_X)+
    (((int)*(imageData+x+y*VIRTUAL_VRAM_SIZE_X+1)) << 8);
}
